#    This file is part of the LinuxCNC Machine Builder, a graphical
#    configuration editor for LinuxCNC. Copyright 2013 Arvid Brodin.
#
#    Although all the code is new, this program is influenced by
#    PNCconf (Copyright 2009 Chris Morley), in turn based on stepconf,
#    a graphical configuration editor for linuxcnc (Copyright 2007 Jeff
#    Epler).
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import time

class Machine(object):

	def __init__(self, name):
		self._name = name
		self._cards = []
		self._joints = []

	def add_joint(self, joint):
		self._joints.append(joint)

	def generate_hal(self):
		filename = self._name + ".hal"
		file = open(filename, "w")
		print >>file, "# Generated by the LinuxCNC Machine Builder at %s" % time.asctime()
		print >>file, "# If you make changes to this file, they will be overwritten"
		print >>file, "# when you run the Machine Builder again."
		print >>file
		# loadrt kins
		# loadrt hostmot/drivers
		# ...
		for joint in self._joints:
			joint.generate_hal(file)
